import { registerAs } from '@nestjs/config';
import { Config } from './config';

export interface CarpoolConfig extends Config {
  departureTimeMargin: number;
  recurrentAdValidityDuration: number;
  role: string;
  seatsProposed: number;
  seatsRequested: number;
  strictFrequency: boolean;
}

export default registerAs('carpool', () => ({
  departureTimeMargin: process.env.DEPARTURE_TIME_MARGIN
    ? parseInt(process.env.DEPARTURE_TIME_MARGIN, 10)
    : 900,
  recurrentAdValidityDuration: process.env.RECURRENT_AD_VALIDITY_DURATION
    ? parseInt(process.env.RECURRENT_AD_VALIDITY_DURATION, 10)
    : 365,
  role: process.env.ROLE ?? 'passenger',
  seatsProposed: process.env.SEATS_PROPOSED
    ? parseInt(process.env.SEATS_PROPOSED, 10)
    : 3,
  seatsRequested: process.env.SEATS_REQUESTED
    ? parseInt(process.env.SEATS_REQUESTED, 10)
    : 1,
  strictFrequency: process.env.STRICT_FREQUENCY
    ? process.env.STRICT_FREQUENCY === 'false'
      ? false
      : true
    : false,
}));
