import { Injectable } from '@nestjs/common';
import { ConfigurationResponseDto } from './interface/dtos/configuration.response.dto';
import { Identifier, Value } from '@mobicoop/configuration-module';
import { ConfigurationsManagerService } from './core/application/services/configurations-manager.service';

@Injectable()
export class ConfigurationMapper {
  constructor(
    private readonly configurationsManager: ConfigurationsManagerService,
  ) {}

  toResponse = (
    identifier: Identifier,
    value: Value,
  ): ConfigurationResponseDto => {
    const response = new ConfigurationResponseDto();
    response.domain = identifier.domain;
    response.key = identifier.key;
    response.value = value;
    response.type = this.configurationsManager.configurationType(value);
    return response;
  };
}
